function [psnr,snr,sqrtmse] = PSNR(I1,I2);

% [PSNR,SQRTMSE,MSESG] = PSNR(I1,I2,SG)
%	Computes Peak To Signal Ratio (PSNR), square root of mean
%	square error (SQRTMSE) 
%
% See also MSE

I1 = double(I1(:));
I2 = double(I2(:));
D = length(I1); 

% check correct sizes ...
if size(I1,1) ~= size(I2,1) | size(I1,2) ~= size(I2,2)
  error('Images I1 and I2 must have same size');
end

% ... and compute vals ...
sqrtmse = sqrt(((I1 - I2)'*(I1 - I2)) / D);

psnr = 20 * log10(255/sqrtmse);
snr = 20 * log10(std(I1(:))/sqrtmse);
