% This script demonstrates how to operate the denoising software. Just
% follow line by line, it's very simple ...

% ... first add some nice software ...
addpath([pwd '\Portilla']);
addpath([pwd '\Simoncelli_PyrTools']);
addpath([pwd]);

% ... load the images ... 
%im = double(imread('images/lena.png'));
%im = double(imread('images/barbara.png'));
im = double(imread('images/house.png'));

% ... create a noisy version of it ...
sig = 15;
im_noisy = sig * randn(size(im)) + im;
[psnrIn,sqrtMseIn] = PSNR(im,im_noisy);

% ... set a set of options (try 'help newOptions') ... 
options = newOptions;
options.mapsteps = 20;
options.pyrtype = 'fullsf';
options.nOrientations = 4;
options.thresh = 0.3;
options.adaptneighbours = 1;
options.block = [1 1];
options.Nsize2 = 11;

% ... and denoise the image ...
im_denoised = denoise_main(im_noisy,sig^2,options);

% ... measure the quality of reconstruction ...
[psnrOut,sqrtMseOut] = PSNR(im,im_denoised);

figure(1); clf;
imagesc(im); axis off equal; colormap gray;
title('Original image');
figure(2); clf;
imagesc(im_noisy); axis off equal;colormap gray;
title(sprintf('Noisy image at %.02f dB (PSNR)',psnrIn));
figure(3); clf;
imagesc(im_denoised); axis off equal;colormap gray;
title(sprintf('PoEdges denoised %.02f dB (PSNR)',psnrOut));